﻿using System;
using Microsoft.Practices.Prism.StoreApps;
using Microsoft.Practices.Prism.StoreApps.Interfaces;
using Windows.UI.Popups;

namespace RadialMenuPrismTest.ViewModels
{
    public class MainPageViewModel : ViewModel
    {

        public bool RadialMenuIsVisible
        {
            get { return _radialMenuIsVisible; }
            set { SetProperty(ref _radialMenuIsVisible, value); }
        }

        public bool RadialMenuIsOpen
        {
            get { return _radialMenuIsOpen; }
            set { SetProperty(ref _radialMenuIsOpen, value); }
        }

        public double RadialMenuTranslateX
        {
            get { return _radialMenuTranslateX; }
            set { SetProperty(ref _radialMenuTranslateX, value); }
        }

        public double RadialMenuTranslateY
        {
            get { return _radialMenuTranslateY; }
            set { SetProperty(ref _radialMenuTranslateY, value); }
        }

        public double PointerPositionX
        {
            get { return _pointerPositionX; }
            set { SetProperty(ref _pointerPositionX, value); }
        }

        public double PointerPositionY
        {
            get { return _pointerPositionY; }
            set { SetProperty(ref _pointerPositionY, value); }
        }


        public DelegateCommand SelectionChangedCommand { get; set; }
        public DelegateCommand SelectCommand { get; set; }
        public DelegateCommand ManageCommand { get; set; }


        public MainPageViewModel(INavigationService navigationService)
        {
            _navigationService = navigationService;

            SelectionChangedCommand = new DelegateCommand(SelectionChanged);
            SelectCommand = new DelegateCommand(Select);
            ManageCommand = new DelegateCommand(Manage);
        }
        
        private void SelectionChanged()
        {
            RadialMenuTranslateX = PointerPositionX;
            RadialMenuTranslateY = PointerPositionY;

            RadialMenuIsVisible = true;
            RadialMenuIsOpen = true;     
        }

        private async void Select()
        {
            await new MessageDialog("", "Select clicked").ShowAsync();
        }

        private async void Manage()
        {
            await new MessageDialog("", "Manage clicked").ShowAsync();
        }

        private INavigationService _navigationService;
        private bool _radialMenuIsVisible;
        private bool _radialMenuIsOpen;
        private bool _radialMenuFirstLoad = true;
        private double _radialMenuTranslateX;
        private double _radialMenuTranslateY;
        private double _pointerPositionX;
        private double _pointerPositionY;

    }
}
