﻿using Microsoft.Practices.Prism.StoreApps;
using RadialMenuPrismTest.ViewModels;
using Syncfusion.UI.Xaml.Controls.Navigation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

namespace RadialMenuPrismTest.Views
{
    public sealed partial class MainPage : VisualStateAwarePage
    {
        MainPageViewModel _viewModel;

        bool _lostfocus = false, _selection = false;

        public MainPage()
        {
            this.InitializeComponent();
            _viewModel = this.DataContext as MainPageViewModel;
        }

        private void GridView_PointerMoved(object sender, PointerRoutedEventArgs e)
        {
            Windows.UI.Xaml.Input.Pointer ptr = e.Pointer;
            if (ptr.PointerDeviceType == Windows.Devices.Input.PointerDeviceType.Mouse)
            {
                Windows.UI.Input.PointerPoint ptrPt = e.GetCurrentPoint((sender as Grid));

                _viewModel.PointerPositionX = ptrPt.Position.X - (radialMenu.ActualWidth / 2);
                _viewModel.PointerPositionY = ptrPt.Position.Y - (radialMenu.ActualHeight / 2);

            }
            _lostfocus = false;
        }

        private void radialMenu_Loaded(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            _viewModel.RadialMenuIsVisible = false;
            _viewModel.RadialMenuIsOpen = true;
        }

        private void GridView_PointerExited_1(object sender, PointerRoutedEventArgs e)
        {
            _lostfocus = true;
        }

        private void GridView_GotFocus_1(object sender, RoutedEventArgs e)
        {
            _selection = true;
            _lostfocus = false;
        }

        private void GridView_LostFocus_1(object sender, RoutedEventArgs e)
        {
            _selection = false;
            if (_lostfocus && !_selection)
            {
                gridView.SelectedIndex = -1;
                radialMenu.Visibility = Visibility.Collapsed;
            }
        }
    }
}
