﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Controls.Navigation;
using Windows.UI.Popups;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RadialMenuTest
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        double transx = 0, transy = 0;
        bool Lostfocus = false, Selection = false;

        public MainPage()
        {
            this.InitializeComponent();
        }

        
        private void radialMenu_Loaded_1(object sender, RoutedEventArgs e)
        {
            (sender as SfRadialMenu).Visibility = Visibility.Collapsed;
            (sender as SfRadialMenu).IsOpen = true;
        }

        private void Grid_PointerMoved_1(object sender, PointerRoutedEventArgs e)
        {
            Windows.UI.Xaml.Input.Pointer ptr = e.Pointer;
            if (ptr.PointerDeviceType == Windows.Devices.Input.PointerDeviceType.Mouse)
            {
                Windows.UI.Input.PointerPoint ptrPt = e.GetCurrentPoint((sender as Grid));

                transx = ptrPt.Position.X - (radialMenu.ActualWidth / 2);
                transy = ptrPt.Position.Y - (radialMenu.ActualHeight / 2);

            }
            Lostfocus = false;
        }

        private void GridView_SelectionChanged_1(object sender, SelectionChangedEventArgs e)
        {
            transform2.TranslateX = transx;
            transform2.TranslateY = transy;
            radialMenu.Visibility = Visibility.Visible;
            radialMenu.IsOpen = true;
        }

        private void GridView_PointerExited_1(object sender, PointerRoutedEventArgs e)
        {
            Lostfocus = true; 
        }

        private void GridView_GotFocus_1(object sender, RoutedEventArgs e)
        {
            Selection = true;
            Lostfocus = false;
        }

        private void GridView_LostFocus_1(object sender, RoutedEventArgs e)
        {
            Selection = false;
            if (Lostfocus && !Selection)
            {
                gridView.SelectedIndex = -1;
                radialMenu.Visibility = Visibility.Collapsed;
            }
        }

        private async void SelectItem_Click(object sender, RoutedEventArgs e)
        {
            await new MessageDialog("", "Select Clicked").ShowAsync();
        }

        private async void ManageItem_Click(object sender, RoutedEventArgs e)
        {
            await new MessageDialog("", "Manage Clicked").ShowAsync();
        }
 
 
    }
}
